function Main() {
    const request = new XMLHttpRequest();
    request.onreadystatechange = () => {
        window.console.log(request.getAllResponseHeaders());
        if (request.readyState === XMLHttpRequest.DONE) {
            if (request.getResponseHeader('Content-Type')?.includes('application/json')) {
                const response: { rates: any } = window.JSON.parse(request.responseText);
                window.alert("For 1 US Dollar (USD) to MAD (Moroccan Dirham): " + response.rates.MAD);
            }
        }
    };
    // This Web site requires a license key after signing in:
    request.open("GET", "http://openexchangerates.org/api/latest.json" + "?app_id=" + "678cd96edd4b4f3eb637bf74ef8e0815", true);
    // 'request' must already be opened:
    request.send(null);

    const request2 = new XMLHttpRequest(); // Stuck by CORS
    request2.onreadystatechange = () => {
        if (request2.readyState === 4)
            window.alert("'request2': " + request2.responseText);
    };
    request2.open("POST", "http://www.w3schools.com" + "/xml/tempconvert.asmx/CelsiusToFahrenheit", true);
    // request2.setRequestHeader("Content-Length", 10); // The number of bytes of data in the body of the request or response
    request2.setRequestHeader("Content-Type", "application/x-www-form-urlencoded"); // As HTML form...
    request2.send("Celsius=20");
}

class ReqRes {
    static URL() {
        return "https://reqres.in";
    }

    static Path() {
        return "/api/users";
    }

    static Run1(name = "FranckBarbier", job = "Trainer") {
        fetch(ReqRes.URL() + ReqRes.Path(), {
            body: JSON.stringify({
                name: name,
                job: job
            }),
            headers: {// Mandatory to get 'result' in appropriate shape...
                'accept': 'application/json', // -> response
                'content-type': 'application/json; charset=UTF-8'
            },
            method: 'POST'
        }).then(response => {
            response.json().then(result => {
                window.console.assert(result.name === name); // 'Req-Res' just returns data for "simulation"...
                window.alert("'ReqRes' ('fetch') RUN1: " + JSON.stringify(result));
            });
        });
    }
}

window.onload = (event: Event) => {
    ReqRes.Run1();
};

